/*-
 * ========================LICENSE_START=================================
 * org.etsi.osl.tmf.api
 * %%
 * Copyright (C) 2019 openslice.io
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =========================LICENSE_END==================================
 */
package org.etsi.osl.tmf.pm632.repo;

import java.util.List;
import java.util.Optional;
import org.etsi.osl.tmf.pm632.model.Individual;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.stereotype.Repository;



@Repository
public interface IndividualRepository extends CrudRepository<Individual, Long>, PagingAndSortingRepository<Individual, Long> {


	Optional<Individual> findByUuid(String id);
	
	Iterable<Individual> findByFamilyName( String name);
	
	List<Individual> findByOrderByFamilyName();

	Optional<Individual> findByPreferredGivenName(String username);

}
